package src.data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class Art_Armor extends BaseHullMod {

    private static final int EMPDAMAGE = 50;
    private static final int WEAPONHEALTH = 50;
    private static final int WEAPONRANGE = 20;
    private static final int CREWLOSS = 10;
    private static final int CRMALFUNCTION = 25;
    private static final int HEDAMAGE = 50;
    private static final int DAMAGE =0; //25;


    @Override
    public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
        stats.getEmpDamageTakenMult().modifyMult(id, 1 - EMPDAMAGE / 100);
        stats.getWeaponHealthBonus().modifyPercent(id, WEAPONHEALTH);
        stats.getBallisticWeaponRangeBonus().modifyPercent(id, WEAPONRANGE);
        stats.getCrewLossMult().modifyMult(id, 1 - CREWLOSS / 100);
        stats.getCriticalMalfunctionChance().modifyMult(id, 1 - CRMALFUNCTION / 100);
        stats.getHighExplosiveDamageTakenMult().modifyMult(id, 1 - HEDAMAGE / 100);
        stats.getArmorDamageTakenMult().modifyMult(id, 1 - DAMAGE / 100);
    }

    @Override
    public String getDescriptionParam(int index, HullSize hullSize) {
        if (index == 0) {
            return "" + WEAPONHEALTH;
        }
        if (index == 1) {
            return "" + WEAPONRANGE;
        }
        if (index == 2) {
            return "" + EMPDAMAGE;
        }
        if (index == 3) {
            return "" + HEDAMAGE;
        }
        if (index == 4) {
            return "" + DAMAGE;
        }
        return null;
    }

    @Override
    public boolean isApplicableToShip(ShipAPI ship) {
        return true;
    }
}
