package src.data.scripts.world;

import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.PluginPick;
import com.fs.starfarer.api.campaign.CampaignPlugin;
import com.fs.starfarer.api.combat.MissileAIPlugin;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAIConfig;
import com.fs.starfarer.api.combat.ShipAIPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.fleet.FleetMemberAPI;
import src.data.scripts.ai.*;
import exerelin.campaign.SectorManager;
import org.dark.shaders.util.ShaderLib;
import org.dark.shaders.util.TextureData;

public class Art_artefactModPlugin extends BaseModPlugin {

    private final String IDEnem = "Art_Enem_shot";
    private final String IDSpreadGun = "Art_SpreadGun_shot";
    private final String IDSpreadGunMIRV = "Art_SpreadGun_mirv2_shot";

    private final String IDShard = "Art_Shard_shot";
    private final String IDSTING = "Art_Sting_shot";

    private final String IDLStulard = "Art_LStulard_shot";
    private final String IDNStulard = "Art_NStulard_shot";
    private final String IDHStulard_ROCKET = "Art_HStulard_shot";
    private final String IDHStulard_HOLE = "Art_Black_Hole_shot";
    private final String IDLILI = "Art_Lili_shot";
    private final String IDAME = "Art_AmeMissile_shot";

    private static void initartefact() {
        boolean haveNexerelin = Global.getSettings().getModManager().isModEnabled("nexerelin");
        if (!haveNexerelin || SectorManager.getCorvusMode()) {
            new Art_Gen().generate(Global.getSector());
        }

    }
    public static boolean hasGraphicsLib;  
      
    @Override  
    public void onApplicationLoad() {  
        hasGraphicsLib = Global.getSettings().getModManager().isModEnabled("shaderLib");  
      
        if (hasGraphicsLib) {  
            ShaderLib.init();  
            //LightData.readLightDataCSV("data/lights/your_light_data.csv");  
           TextureData.readTextureDataCSV("data/lights/Art_texture_data.csv");  
        }  
    }  
 


    @Override
    public void onNewGame() {
        initartefact();
    }

    @Override
    public PluginPick<MissileAIPlugin> pickMissileAI(MissileAPI missile, ShipAPI launchingShip) {

        switch (missile.getProjectileSpecId()) {
            case IDShard:
                return new PluginPick<MissileAIPlugin>(new Art_Shard_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDEnem:
                return new PluginPick<MissileAIPlugin>(new Art_Enem_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDAME:
                return new PluginPick<MissileAIPlugin>(new Art_AmeMissile_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDLILI:
            case IDSTING:
                return new PluginPick<MissileAIPlugin>(new Art_Sting_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDSpreadGun:
                return new PluginPick<MissileAIPlugin>(new Art_SpreadGun_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDNStulard:
                return new PluginPick<MissileAIPlugin>(new Art_Stulard_ai(missile, launchingShip, 5), CampaignPlugin.PickPriority.MOD_SET);
            case IDLStulard:
                return new PluginPick<MissileAIPlugin>(new Art_Stulard_ai(missile, launchingShip, 10), CampaignPlugin.PickPriority.MOD_SET);
            case IDHStulard_ROCKET:
                return new PluginPick<MissileAIPlugin>(new Art_Stukov_Huge_ai(missile), CampaignPlugin.PickPriority.MOD_SET);
            case IDHStulard_HOLE:
                return new PluginPick<MissileAIPlugin>(new Art_Black_Hole_ai(missile, new Art_Spreadgun_mirv_ai(missile, launchingShip), launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            case IDSpreadGunMIRV:
                return new PluginPick<MissileAIPlugin>(new Art_Spreadgun_mirv_ai(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            default:
                return null;
        }
    }
}
