package src.data.scripts.world.systems;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.JumpPointAPI;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.OrbitAPI;
import com.fs.starfarer.api.campaign.PlanetAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.impl.campaign.ids.StarTypes;
import com.fs.starfarer.api.impl.campaign.ids.Terrain;
import com.fs.starfarer.api.impl.campaign.procgen.StarAge;
import com.fs.starfarer.api.impl.campaign.terrain.BaseTiledTerrain;
import com.fs.starfarer.api.impl.campaign.terrain.MagneticFieldTerrainPlugin.MagneticFieldParams;
import com.fs.starfarer.api.util.Misc;
import java.awt.Color;

public class noirGen {

    //@Override
    public void generate(SectorAPI sector) {

        /*      uclora
mefleshan*/
        StarSystemAPI system = sector.createStarSystem("Uclora");
        system.getLocation().set(-10000, -17000);
        LocationAPI hyper = Global.getSector().getHyperspace();

        system.setBackgroundTextureFilename("graphics/backgrounds/Noir_back.jpg");

        SectorEntityToken center= system.initNonStarCenter();
        
        // create the star and generate the hyperspace anchor for this system
        PlanetAPI star = system.initStar("nebula", StarTypes.RED_SUPERGIANT, 500f, 400f);
        system.setLightColor(new Color(233, 85, 22)); // light color in entire system, affects all entities
        PlanetAPI planet1 = system.addPlanet("unknow", star, "Unknow", "jungle", 300, 200, 4800, 200);
        planet1.getSpec().setTexture(Global.getSettings().getSpriteName("planets", "barren02"));
        planet1.getSpec().setGlowTexture(Global.getSettings().getSpriteName("hab_glows", "sindria"));
        planet1.getSpec().setGlowColor(new Color(255, 255, 255, 255));
        planet1.getSpec().setUseReverseLightForGlow(true);
        planet1.applySpecChanges();
        planet1.setInteractionImage("illustrations", "industrial_megafacility");
        //planet1.setCustomDescriptionId("unknow");
        PlanetAPI planet2 = system.addPlanet("met", star, "Met", "terran", 270, 100, 5000, 200);
        planet2.getSpec().setTexture(Global.getSettings().getSpriteName("planets", "barren02"));
        planet2.getSpec().setGlowTexture(Global.getSettings().getSpriteName("hab_glows", "sindria"));
        planet2.getSpec().setGlowColor(new Color(255, 255, 255, 255));
        planet2.getSpec().setUseReverseLightForGlow(true);
        planet2.applySpecChanges();
        planet2.setInteractionImage("illustrations", "industrial_megafacility");
        // planet2.setCustomDescriptionId("met");

        SectorEntityToken relay = system.addCustomEntity("unknow_relay", // unique id
                "Unknow Relay", // name - if null, defaultName from custom_entities.json will be used
                "comm_relay", // type of object, defined in custom_entities.json
                "noir"); // faction
        //orbits ilkhanna
        relay.setCircularOrbit(system.getEntityById("unknow"), 120, 1400, 100);

        JumpPointAPI jumpPoint = Global.getFactory().createJumpPoint("sing_jump_alpha", "Jump Point");
        OrbitAPI orbit = Global.getFactory().createCircularOrbit(star, 135, 800, 40);
        jumpPoint.setOrbit(orbit);
        jumpPoint.setRelatedPlanet(planet1);
        jumpPoint.setStandardWormholeToHyperspaceVisual();
        system.addEntity(jumpPoint);

        SectorEntityToken station = system.addCustomEntity("unknow_station", "Tao", "station_side02", "noir");
        station.setCircularOrbitPointingDown(system.getEntityById("unknow"), 45, 300, 50);

        SectorEntityToken ucloraI = system.addPlanet("noir_uclora", star, "I-Uclora", "gas_giant", 200, 300, 7800, 400);

        // Barad magnetic field
        SectorEntityToken barad_field = system.addTerrain(Terrain.MAGNETIC_FIELD,
                new MagneticFieldParams(ucloraI.getRadius() + 200f, // terrain effect band width 
                        (ucloraI.getRadius() + 200f) / 2f, // terrain effect middle radius
                        ucloraI, // entity that it's around
                        ucloraI.getRadius() + 50f, // visual band start
                        ucloraI.getRadius() + 50f + 250f, // visual band end
                        new Color(50, 20, 100, 40), // base color
                        0.5f, // probability to spawn aurora sequence, checked once/day when no aurora in progress
                        new Color(140, 100, 235),
                        new Color(180, 110, 210),
                        new Color(150, 140, 190),
                        new Color(140, 190, 210),
                        new Color(90, 200, 170),
                        new Color(65, 230, 160),
                        new Color(20, 220, 70)
                ));
        barad_field.setCircularOrbit(ucloraI, 0, 0, 100);

        SectorEntityToken corvusIIIA = system.addPlanet("corvus_IIIa", ucloraI, "Garnir", "cryovolcanic", 135, 100, 790, 20);
        corvusIIIA.setCustomDescriptionId("planet_barad_a");

     /*   // Pirate Station
        SectorEntityToken pirateStation = system.addCustomEntity("corvus_pirate_station",
                "Garnir Extraction Depot", "station_mining00", "pirates");
        pirateStation.setCircularOrbitPointingDown(system.getEntityById("corvus_IIIa"), 45, 170, 20);
        pirateStation.setCustomDescriptionId("pirate_base_barad");
        pirateStation.setInteractionImage("illustrations", "pirate_station");

        //system.addAsteroidBelt(corvusIII, 50, 1000, 200, 10, 45, Terrain.ASTEROID_BELT, null);
        system.addRingBand(corvusIII, "misc", "rings_ice0", 256f, 2, Color.white, 256f, 1050, 45, Terrain.RING, null);

        SectorEntityToken corvusIIIB = system.addPlanet("corvus_IIIb", corvusIII, "Warion", "barren", 235, 70, 1300, 60);
        // corvusIIIB.setInteractionImage("illustrations", "vacuum_colony");
*/
        SectorEntityToken Nebula_nebula = Misc.addNebulaFromPNG("data/campaign/terrain/Nebula_nebula.png",
                0, 0, // center of nebula
                system, // location to add to
                "terrain", "nebula_amber", //"nebula_blue", // texture to use, uses xxx_map for map
                4, 4, StarAge.OLD); // number of cells in texture        
        SectorEntityToken Nebula_nebula2 = Misc.addNebulaFromPNG("data/campaign/terrain/Nebula_nebula.png",
                0, 0, // center of nebula
                system, // location to add to
                "terrain", "nebula_amber", //"nebula_blue", // texture to use, uses xxx_map for map
                130, 130, StarAge.AVERAGE); // number of cells in texture        

        SectorEntityToken small1_nebula = system.addTerrain(Terrain.NEBULA, new BaseTiledTerrain.TileParams(
                "  x   "
                + "  xx x"
                + "xxxxx "
                + " xxx  "
                + " x  x "
                + "   x  ",
                6, 6, // size of the nebula grid, should match above string
                "terrain", "nebula", 4, 4, null));

        SectorEntityToken small2_nebula = system.addTerrain(Terrain.NEBULA, new BaseTiledTerrain.TileParams(
                "  x   "
                + " xx xx"
                + "x  xx "
                + " xxxx "
                + " x x x"
                + "  x   ",
                6, 6, // size of the nebula grid, should match above string
                "terrain", "nebula", 4, 4, null));
        SectorEntityToken small3_nebula = system.addTerrain(Terrain.NEBULA, new BaseTiledTerrain.TileParams(
                "   xx "
                + "  xx x"
                + " xxxx "
                + "xxxxxx"
                + "  xx  "
                + "    x ",
                6, 6, // size of the nebula grid, should match above string
                "terrain", "nebula", 4, 4, null));
        small3_nebula.getLocation().set(star.getLocation().x + 1000f, star.getLocation().y);
        small3_nebula.setCircularOrbit(star, 140f, 11000, 500);
        small1_nebula.setCircularOrbit(star, 130 - 60, 10000, 500);
        small2_nebula.setCircularOrbit(star, 130 + 60, 10000, 500);

        system.autogenerateHyperspaceJumpPoints(true, true);

    }
}
